=== debian/control ===
Source: ros-galactic-cyclonedds
Section: misc
Priority: optional
Maintainer: Eclipse Foundation, Inc. <cyclonedds-dev@eclipse.org>
Build-Depends: debhelper (>= 9.0.0), bison, cmake, libcunit1-dev, libssl-dev, ros-galactic-iceoryx-binding-c, ros-galactic-iceoryx-posh, ros-galactic-iceoryx-utils, ros-galactic-ros-workspace
Homepage: https://projects.eclipse.org/projects/iot.cyclonedds
Standards-Version: 3.9.2

Package: ros-galactic-cyclonedds
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, openssl, ros-galactic-iceoryx-binding-c, ros-galactic-iceoryx-posh, ros-galactic-iceoryx-utils, ros-galactic-ros-workspace
Description: Eclipse Cyclone DDS is a very performant and robust open-source DDS implementation.
 Cyclone DDS is developed completely in the open as an Eclipse IoT project.
